import re

from server import *

LDAP_USERRE = re.compile(r'[^a-z0-9]')
if 'LDAP_HOST' in config:
	import ldap3

	def ldapauth(user, password): # pylint: disable=function-redefined
		if LDAP_USERRE.search(user):
			return {}, []
		try:
			server = ldap3.Server(config['LDAP_HOST'], port=config['LDAP_PORT'], use_ssl=True)
			conn = ldap3.Connection(server, 'fsmpi\\%s'%user, password, auto_bind=True, check_names=False)
		except (ldap3.core.exceptions.LDAPBindError, ldap3.core.exceptions.LDAPPasswordIsMandatoryError):
			return {}, []
		conn.search("cn=users,dc=fsmpi,dc=rwth-aachen,dc=de", "(cn=%s)"%user, attributes=['memberOf', 'givenName', 'sn'])
		info = {'uid': user, 'givenName': conn.response[0]['attributes']['givenName'][0], 'sn': conn.response[0]['attributes']['sn'][0]}
		groups = [g.split(',')[0].split('=')[-1] for g in conn.response[0]['attributes']['memberOf']]
		conn.unbind()
		return info, groups

else:
	NOTLDAP = {
		'videoag': ('videoag', ['fachschaft', 'videoag'], {'uid': 'videoag', 'givenName': 'Video', 'sn': 'Geier'}),
		'gustav': ('passwort', ['fachschaft'], {'uid': 'gustav', 'givenName': 'Gustav', 'sn': 'Geier'})
	}

	def ldapauth(user, password): # pylint: disable=function-redefined
		if LDAP_USERRE.search(user):
			return {}, []
		if config.get('DEBUG') and user in NOTLDAP and password == NOTLDAP[user][0]:
			return NOTLDAP[user][2], NOTLDAP[user][1]
		return {}, []
