#!/usr/bin/env python3
import unittest
import os
import server

def set_up():
	server.app.testing = True

def tear_down():
	os.unlink(server.app.config['SQLITE_DB'])

if __name__ == '__main__':
	set_up()
	try:
		suite = unittest.defaultTestLoader.discover('./tests/', pattern="*") #pylint: disable=invalid-name
		unittest.TextTestRunner(verbosity=2, failfast=True).run(suite)
	finally:
		tear_down()
