import threading
import sched
from time import sleep

from server import *

scheduler = sched.scheduler() # pylint: disable=invalid-name
def run_scheduler():
	sleep(1) # UWSGI does weird things on startup
	while True:
		scheduler.run()
		sleep(10)

def sched_func(delay, priority=0, firstdelay=None, args=None, kargs=None):
	args = args or []
	kargs = kargs or {}
	if firstdelay is None:
		firstdelay = random.randint(1, 120)
	def wrapper(func):
		def sched_wrapper():
			with app.test_request_context(base_url='https://video.fsmpi.rwth-aachen.de/'):
				try:
					if config.get('DEBUG', False):
						print("Scheduler: started {} (frequency 1/{}s)".format(func.__name__, delay))
					func(*args, **kargs)
				except Exception: # pylint: disable=broad-except
					traceback.print_exc()
					notify_admins('scheduler_exception', name=func.__name__,
							traceback=traceback.format_exc())
			scheduler.enter(delay, priority, sched_wrapper)
		scheduler.enter(firstdelay, priority, sched_wrapper)
		print("Scheduler: registered {} (frequency 1/{}s, start delay: {}s)".format(func.__name__, delay, firstdelay))
		return func
	return wrapper
if not app.config['DISABLE_SCHEDULER']:
	threading.Thread(target=run_scheduler, daemon=True).start()
